// ListCtrlColorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ListCtrlColor.h"
#include "ListCtrlColorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
  afx_msg void OnBnClickedOk();
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
  ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListCtrlColorDlg dialog

CListCtrlColorDlg::CListCtrlColorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CListCtrlColorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CListCtrlColorDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CListCtrlColorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CListCtrlColorDlg)
	DDX_Control(pDX, IDC_LIST2, m_listctrl);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CListCtrlColorDlg, CDialog)
	//{{AFX_MSG_MAP(CListCtrlColorDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
  ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListCtrlColorDlg message handlers

BOOL CListCtrlColorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_listctrl.InsertColumn(0,"label",LVCFMT_LEFT,60,0);
	m_listctrl.InsertColumn(1,"first",LVCFMT_LEFT,40,1);
	m_listctrl.InsertColumn(2,"second",LVCFMT_LEFT,30,2);
	m_listctrl.InsertColumn(3,"third",LVCFMT_LEFT,20,3);

	int row;
	row = m_listctrl.InsertItem(0,"row1");
	m_listctrl.SetItem(row,1,LVIF_TEXT,"aaa",0,0,0,0);
	m_listctrl.SetItem(row,2,LVIF_TEXT,"bbb",0,0,0,0);
	m_listctrl.SetItem(row,3,LVIF_TEXT,"ccc",0,0,0,0);
	row = m_listctrl.InsertItem(1,"row2");
	m_listctrl.SetItem(row,1,LVIF_TEXT,"AAA",0,0,0,0);
	m_listctrl.SetItem(row,2,LVIF_TEXT,"BBB",0,0,0,0);
	m_listctrl.SetItem(row,3,LVIF_TEXT,"CCC",0,0,0,0);
	row = m_listctrl.InsertItem(2,"row3");
	m_listctrl.SetItem(row,1,LVIF_TEXT,"X",0,0,0,0);
	m_listctrl.SetItem(row,2,LVIF_TEXT,"YY",0,0,0,0);
	m_listctrl.SetItem(row,3,LVIF_TEXT,"ZZZ",0,0,0,0);

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CListCtrlColorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CListCtrlColorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CListCtrlColorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CListCtrlColorDlg::OnBnClickedButton1()
{
  CAboutDlg().DoModal();
}

void CAboutDlg::OnBnClickedOk()
{
  CWaitCursor wait;

  CString strUrl = "http://www.thecodechannel.com/redirect.asp?u=/&s=vcnb";
  if (32 >= (int)ShellExecute(NULL, "open", strUrl, NULL, NULL, SW_SHOWNORMAL))
  {
    AfxMessageBox("::ShellExecute failed to open this link!");
  }
}
